/*
    Copyright (c) 2002-2011 Tampere University of Technology.

    This file is part of TTA-Based Codesign Environment (TCE).

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.
 */
/**
 * Light Weight PRinting library.
 *
 * For stdout printing needs where putchar() or puts() do not suffice 
 * but printf() is overkill. Uses putchar() for character output.
 * 
 * @author Pekka Jääskeläinen 2011
 */
#ifndef _LWPR_H
#define _LWPR_H


/**
 * Prints the given string *without* a trailing newline (like with puts).
 */
void lwpr_print_str(char* str);

/**
 * Prints an integer.
 */
void lwpr_print_int(int n);

/**
 * Prints an integer as a hexadecimal.
 */
void lwpr_print_hex(int n);

/**
 * Prints newline
 */
#define lwpr_newline() _TCE_STDOUT('\n');

#endif
